"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.debug = void 0;
// import { load_settings_env, SrcFn, DestFns } from '../settings'
const ngrok_1 = require("../ngrok");
// import { server } from '../server'
const deployer_1 = require("../deployer");
// // import * as path from 'path'
// import { exec } from 'child_process'
const settings_1 = require("../settings");
const server_1 = require("../server");
const sam_1 = require("../sam");
async function debug(type, access_token, tunnel) {
    let settings = await settings_1.load_settings(settings_1.get_settings_file());
    let debug_url;
    if ((type == 'remote' || type == 'segment') && !tunnel && settings.proxy_port && settings.use_ngrok) {
        [debug_url] = await ngrok_1.launch(settings.proxy_port);
        console.log('Local instance publicly available at: ' + debug_url);
        // if (type == 'segment') {
        //   tunnel = url
        // }
    }
    if ((type == 'segment') && !(debug_url || tunnel)) {
        console.error('No public URL available for running this type of debug instance (' + type + ')');
        return;
    }
    if (type == 'segment') {
        if (!settings.work_id) {
            console.error('Workspace ID must be provided for running this type of debug instance (' + type + ')');
            return;
        }
        if (!settings.access_token && !access_token) {
            console.error('Access token must be provided for running this type of debug instance (' + type + ')');
            return;
        }
        // let fn_dir = path.join(process.cwd(), settings.language == 'javascript' ? 'src' : 'out')
        if (settings.fn_type == 'source') {
            deployer_1.deploy_source(settings, access_token, debug_url || tunnel); //get_deploy_file(settings), true, tunnel as string, settings.fn_name, settings.work_id, (access_token || settings.access_token) as string)
        }
        else {
            deployer_1.deploy_destination(settings, access_token, debug_url || tunnel); //get_deploy_file(settings), true, tunnel as string, settings.fn_name, settings.work_id, (access_token || settings.access_token) as string)
        }
    }
    if (type == 'remote' || type == 'segment') {
        await server_1.server(settings);
    }
    sam_1.run_exec(settings, true);
    // if (settings.language) {
    //   exec(`tsc -p .`, async (error, _, stderr) => {
    //     if (error) {
    //       console.error(error)
    //     } else {
    //       if (stderr) {
    //         console.error(error)
    //       }
    //       let e = `sam local start-api --port ${settings.sam_port} --debug-port ${settings.debug_port}`
    //       // let e = `nodemon --watch src -e ts --exec "tsc -p .;sam local start-api --port 3001"`
    //       let is_nodemon = await nodemon_installed()
    //       if (is_nodemon) {
    //       }
    //     }
    //   })
    // }
    // exec(`sam local start-api --port ${settings.sam_port} --debug-port ${settings.debug_port}`, (error, _, stderr) => {
    //   if (error) {
    //     console.error(error)
    //   } else if (stderr) {
    //     console.error(stderr)
    //   }
    // })
}
exports.debug = debug;
// export default function (src_fn?: SrcFn, dest_fn?: DestFns) {
//   let settings = load_settings_env(process.cwd(), src_fn, dest_fn)
//   if (settings) {
//     if (Array.isArray(settings)) {
//       console.error('Error on lines: ')
//       console.error(JSON.stringify(settings))
//     } else {
//       (async function () {
//         await server(settings.server)
//         let [url, already_deploy] = await launch(settings.server.port || 8000)
//         if (!already_deploy) {
//           await deploy_functions(settings, url, true)
//           console.log('To test the function, send data to:')
//           console.log(url)
//           // if (settings.protocol.src_fn_name) {
//           //   await deploy_source(path.join(process.cwd(), 'src'), true, url, settings.protocol.src_fn_name, settings.protocol.work_slug, settings.server.jwt_token)
//           //   console.log('Deployed source ' + settings.protocol.src_fn_name)
//           // }
//           // if (settings.protocol.dest_fn_name) {
//           //   await deploy_destination(path.join(process.cwd(), 'src'), true, url, settings.protocol.dest_fn_name, settings.protocol.work_slug, settings.server.jwt_token)
//           //   console.log('Deployed destination ' + settings.protocol.dest_fn_name)
//           // }
//         }
//         // }
//       })()
//     }
//   }
// }
//# sourceMappingURL=debug.js.map