"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.run_exec = exports.get_exec = exports.nodemon_installed = void 0;
const child_process_1 = require("child_process");
function nodemon_installed() {
    return new Promise((resolve, reject) => {
        child_process_1.exec(`nodemon --version`, (error, std_out) => {
            if (error) {
                reject(error);
            }
            else {
                resolve(std_out.substring(0, 1).match(/\d/) !== null);
            }
        });
    });
}
exports.nodemon_installed = nodemon_installed;
async function get_exec(settings, is_debug) {
    let e = `sam local start-api --port ${settings.sam_port}`;
    if (is_debug) {
        e = `${e} --debug-port ${settings.debug_port}`;
    }
    if (settings.language == 'typescript') {
        e = `tsc -p .;${e}`;
    }
    let is_nodemon = await nodemon_installed();
    if (is_nodemon) {
        e = `nodemon --watch src -e ts --exec "${e}"`;
    }
    return e;
}
exports.get_exec = get_exec;
async function run_exec(settings, is_debug) {
    let e = await get_exec(settings, is_debug);
    let s = child_process_1.spawn(e, { shell: true, stdio: 'inherit' });
    // s.stdout.on('data', data => {
    //   console.log(data.toString())
    // })
    // s.stderr.on('data', data => {
    //   console.error(data.toString())
    // })
    return s;
}
exports.run_exec = run_exec;
//# sourceMappingURL=sam.js.map