// import { load_settings_env } from '../settings'
import { deploy_source, deploy_destination } from '../deployer'
import { load_settings, get_settings_file, get_deploy_file } from '../settings'
// import * as path from 'path'

export async function deploy(access_token?: string) {
  let settings = await load_settings(get_settings_file())

  if (!settings.work_id) {
    console.error('Workspace ID must be provided in settings file to synchronise tracking plans')
    return
  }
  if (!settings.access_token && !access_token) {
    console.error('Access token must be provided as argument or provided in settings file to synchronise tracking plans')
    return
  }

  if (settings.fn_type == 'source') {
    await deploy_source(settings)//get_deploy_file(settings), false, '', settings.fn_name, settings.work_id, (access_token || settings.access_token) as string)
  } else {
    await deploy_destination(settings)//get_deploy_file(settings), false, '', settings.fn_name, settings.work_id, (access_token || settings.access_token) as string)
  }
}

// export default function () {
//   let settings = load_settings_env(process.cwd())
//   if (settings) {
//     if (Array.isArray(settings)) {
//       console.error('Error on lines: ')
//       console.error(JSON.stringify(settings))
//     } else {
//       (async function () {
//         await deploy_functions(settings, '', false)
//         // if (settings.protocol.src_fn_name) {
//         //   await deploy_source(path.join(process.cwd(), 'src'), false, '', settings.protocol.src_fn_name, settings.protocol.work_slug, settings.server.jwt_token)
//         //   console.log('Deployed source ' + settings.protocol.src_fn_name)
//         // }
//         // if (settings.protocol.dest_fn_name) {
//         //   await deploy_destination(path.join(process.cwd(), 'src'), false, '', settings.protocol.dest_fn_name, settings.protocol.work_slug, settings.server.jwt_token)
//         //   console.log('Deployed destination ' + settings.protocol.dest_fn_name)
//         // }
//       })()
//     }
//   }
// }
