import Koa from 'koa'
import Router from 'koa-router'
import body from 'koa-body'
// import 'segment-typescript-definitions/common'
// import 'segment-typescript-definitions/custom-source'
// import 'segment-typescript-definitions/custom-destination'
import _fetch from 'node-fetch'
import { Settings } from './settings'
import { call_src, call_dest, test_src, test_dest } from '.'
// import { SrcFn, DestFns } from './settings'

// (global as any).Segment = {
//   identify(i: SegmentOptions<SegmentSourceIdentify> & SegmentId) {
//     console.log('--identify')
//     console.log(i)
//   }
// };
// (global as any).Segment = {
//   track<E extends SegmentEvents>(t: SegmentOptions<SegmentTrackObject<E>> & SegmentId) {
//     console.log('--track')
//     console.log(t)
//   }
// };
// (global as any).fetch = _fetch

export async function server(settings: Settings) {
  if (!settings.proxy_port) {
    throw 'Cannot run proxy server without proxy port defined'
  }
  const server = new Koa()
  const router = new Router()

  server.use(body())

  router.post('/', async ctx => {
    if (settings.fn_type == 'source') {
      test_src(ctx.request.body, settings.sam_port)
    } else {
      test_dest(ctx.request.body, settings.sam_port)
    }

    // let { request, settings } = ctx.request.body as { request: SegmentSourceRequest, settings: SegmentSettings }
    // if (settings.fn)
    // if (args.src_fn) {
    //   args.src_fn(request, settings)
    // }
    ctx.body = ''
  })

  // router.post('/test_destination', async ctx => {
  //   if (args.dest_fn) {
  //     let { event, settings } = ctx.request.body as { event: SegmentProcessedEvent<SegmentTrackEvent | SegmentIdentifyEvent | SegmentAliasEvent | SegmentScreenEvent | SegmentPageEvent | SegmentGroupEvent>, settings: SegmentSettings }
  //     switch (event.type) {
  //       case 'alias': {
  //         if (args.dest_fn.onAlias) {
  //           args.dest_fn.onAlias(event, settings)
  //         }
  //         break
  //       }
  //       case 'identify': {
  //         if (args.dest_fn.onIdentify) {
  //           args.dest_fn.onIdentify(event, settings)
  //         }
  //         break
  //       }
  //       case 'page': {
  //         if (args.dest_fn.onPage) {
  //           args.dest_fn.onPage(event, settings)
  //         }
  //         break
  //       }
  //       case 'screen': {
  //         if (args.dest_fn.onScreen) {
  //           args.dest_fn.onScreen(event, settings)
  //         }
  //         break
  //       }
  //       case 'track': {
  //         if (args.dest_fn.onTrack) {
  //           args.dest_fn.onTrack(event, settings)
  //         }
  //         break
  //       }
  //       case 'group': {
  //         if (args.dest_fn.onGroup) {
  //           args.dest_fn.onGroup(event, settings)
  //         }
  //         break
  //       }
  //     }
  //   }
  //   ctx.body = ''
  // })

  let port = settings.proxy_port
  // let host: string|undefined
  // if (tunnel) {
  //   let url = new URL(tunnel)
  //   // host = url.hostname
  //   port = parseInt(url.port)
  //   if (isNaN(port)) {
  //     throw 'Invalid tunnel url: ' + tunnel
  //   }
  // }

  server.use(router.routes())
  server.listen(port)//, host)
}

// export type ServerArgs = {
//   src_fn?: SrcFn
//   dest_fn?: DestFns
//   access_token: string
//   port?: number
// }